=== debian/changelog ===
libusrsctp (0.9.3.0+20201102-2) unstable; urgency=medium

  * add patch 1001 to install pkg-config file;
    have libusrsctp-dev depend on pkg-config
  * declare compliance with Debian Policy 4.5.1

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 30 Nov 2020 02:40:45 +0100

libusrsctp (0.9.3.0+20201102-1) unstable; urgency=medium

  [ upstream ]
  * development snapshot

  [ Jonas Smedegaard ]
  * simplify source script copyright-check
  * copyright: update coverage

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 02 Nov 2020 20:15:31 +0100

libusrsctp (0.9.3.0+20201007-1) unstable; urgency=medium

  [ upstream ]
  * development snapshot

  [ Jonas Smedegaard ]
  * copyright: update coverage
  * update symbols:
    + 1 public symbol added
    + 5 private symbols added
    + 3 private symbols dropped

 -- Jonas Smedegaard <dr@jones.dk>  Sun, 11 Oct 2020 03:19:49 +0200
