=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# TODO: fix code instead!
export DEB_CFLAGS_MAINT_APPEND = -Wno-address-of-packed-member

# Let d-shlibs calculate development package dependencies
#  and handle shared library install
execute_after_dh_install:
	d-shlibmove --commit \
		--devunversioned \
		--exclude-la \
		--multiarch \
		--movedev "debian/tmp/usr/include/*" usr/include/ \
		--movedev "debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/*" \
			usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig \
		debian/tmp/usr/lib/*/*.so

%:
	dh $@ --with pkgkde_symbolshelper
