## libusrsctp 0.9.5.0

=== debian/changelog ===
libusrsctp (0.9.5.0-2build1) noble; urgency=high

  * No change rebuild against frame pointers and time_t.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 22 Apr 2024 11:48:00 +0200

libusrsctp (0.9.5.0-2) unstable; urgency=medium

  * release to unstable

 -- Jonas Smedegaard <dr@jones.dk>  Thu, 19 Aug 2021 22:50:43 +0200

libusrsctp (0.9.5.0-1) experimental; urgency=medium

  [ upstream ]
  * new release

  [ Jonas Smedegaard ]
  * update source helper script copyright-check
  * update watch file: track git tags
  * declare compliance with Debian Policy 4.6.0
  * use debhelper compatibility level 13 (not 12)
  * install to new binary package libusrsctp2
  * drop obsolete libtool linker files before dh_install

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 18 Aug 2021 16:48:32 +0200
