=== debian/control ===
--- 
+++ 
@@ -1,20 +1,21 @@
 Source: libusrsctp
 Section: net
 Priority: optional
-Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
 Uploaders:
  Jonas Smedegaard <dr@jones.dk>,
 Build-Depends:
  d-shlibs,
- debhelper-compat (= 12),
+ debhelper-compat (= 13),
  pkg-kde-tools,
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Vcs-Git: https://salsa.debian.org/pkg-voip-team/libusrsctp.git
 Vcs-Browser: https://salsa.debian.org/pkg-voip-team/libusrsctp
 Homepage: https://github.com/sctplab/usrsctp
 Rules-Requires-Root: no
 
-Package: libusrsctp1
+Package: libusrsctp2
 Section: libs
 Architecture: any
 Multi-Arch: same
@@ -36,7 +37,7 @@
 Architecture: any
 Multi-Arch: same
 Depends:
- libusrsctp1 (= ${binary:Version}),
+ libusrsctp2 (= ${binary:Version}),
  pkg-config,
  ${misc:Depends},
  ${shlibs:Depends},
@@ -53,7 +54,7 @@
 Package: libusrsctp-examples
 Architecture: any
 Depends:
- libusrsctp1 (= ${binary:Version}),
+ libusrsctp2 (= ${binary:Version}),
  ${misc:Depends},
  ${shlibs:Depends},
 Description: portable SCTP userland stack - example programs
